#!/usr/bin/python
# -*- coding: utf-8 -*-

#Copyright (C) 2006-2007  Néstor Arocha Rodríguez, Inmaculada Luengo Merino 

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA



from PyQt4 import QtCore,QtGui
from Driza.iu.ui.dfiltrado import Ui_DialogoFiltro
import logging
log = logging.getLogger("Driza.iu.dialogs.dfiltrado")


class DFiltrado(QtGui.QDialog):
    """Dialogo que permite establecer el filtro"""
    
    def __init__(self,parent,interfazdatosusuario):
        QtGui.QDialog.__init__(self,parent)
        self.ui=Ui_DialogoFiltro()
        self.ui.setupUi(self)
        self.__conexiones()
        self.__idu=interfazdatosusuario

    def __conexiones(self):
        """Función que define las conexiones entre elementos de la interfaz y sus SLOTS"""
        from PyQt4.QtCore import SIGNAL
        self.connect(self.ui.pushButton1,SIGNAL("clicked()"),self.accept)
        self.connect(self.ui.pushButton2,SIGNAL("clicked()"),self.reject)
        self.connect(self.ui.pushButton3,SIGNAL("clicked()"),self.__insertarSimboloGT)
        self.connect(self.ui.pushButton4,SIGNAL("clicked()"),self.__insertarSimboloLT)
        self.connect(self.ui.pushButton5,SIGNAL("clicked()"),self.__insertarSimboloEQ)
        self.connect(self.ui.pushButton6,SIGNAL("clicked()"),self.__insertarSimboloNE)
        self.connect(self.ui.pushButton7,SIGNAL("clicked()"),self.__desactivarfiltro)
        self.connect(self.ui.comboBox1,SIGNAL("activated (int)"),self.__insertarvariable)

    def showEvent(self,ev):
        self.myUpdate()
        QtGui.QDialog.showEvent(self,ev)

    def accept(self):
        expresion=self.textEdit.text().latin1()
        if not expresion:#Si no se rellena nada, se desactiva el filtro
            self.__desactivarfiltro
        else:
            try:
                self.__idu.setFiltro(expresion)
            except:
                log.exception("Capturada excepcion en el manejo del filtro")
            else:
                self.parent().grid.myUpdate()
                QtGui.QDialog.accept(self)

    def __desactivarfiltro(self):
            self.__idu.delFiltro() 
            self.parent().grid.myUpdate()
            QtGui.QDialog.accept(self)


    def __insertarSimboloGT(self):
        self.ui.textEdit.insertPlainText(">")
    def __insertarSimboloLT(self):
        self.ui.textEdit.insertPlainText("<")
    def __insertarSimboloEQ(self):
        self.ui.textEdit.insertPlainText("==")
    def __insertarSimboloNE(self):
        self.ui.textEdit.insertPlainText("!=")

    def __insertarvariable(self,indice=0):
        self.ui.textEdit.insertPlainText(self.ui.comboBox1.currentText())

    def __actualizarcombovars(self):
        """Actualiza la caja de variables disponibles"""
        self.ui.comboBox1.clear()
        for var in self.__idu.arrTit():
            self.ui.comboBox1.addItem(QtCore.QString(var))

    def myUpdate(self):
        self.__actualizarcombovars()


