#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#woperaciones.py: Todos los widgets de operaciones

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from PyQt4 import QtCore,QtGui

class WidgetOperacion(QtGui.QWidget):
    """Clase base de todos los widgets de operaciones"""
    def __init__(self,name):
        if isinstance(name,unicode):
            name=name.encode("latin1")
        if not name:
            self.setName("WidgetOperacion")
        QtGui.QWidget.__init__(self)#,None,name,0)
        self._rejilla=QtGui.QGridLayout(self)#,1,1,11,6,"rejilla")
        self.languageChange()
        self.resize(QtCore.QSize(600,480).expandedTo(self.minimumSizeHint()))
        #TODO Pendiente portabilidad qt4
        #self.clearWState(Qt.WState_Polished)


    def languageChange(self):
        #TODO Pendiente portabilidad qt4
        #self.setCaption(self.__tr("Form1"))
        pass

    def __tr(self,s,c = None):
        return qApp.translate("Form1",s,c)
    
    def seleccion(self):
        return self._wseleccion.seleccion

    def opciones(self):
        return self._wopciones.opciones()

class WidgetOperacionSelectorOpcion(WidgetOperacion):
    """WidgetOperacionSelectorOpcion es un widget de operaciones que tiene un selector y un widget de opciones"""
    def __init__(self,name,widgetselector,widgetopciones,listaopciones):
        WidgetOperacion.__init__(self,name)

        #Condiciones a probar
        from wopciones import WOpciones
        from seleccion import SelectorElementosEstudio
        assert(isinstance(widgetselector,SelectorElementosEstudio))
        assert(isinstance(widgetopciones,WOpciones))

        #Inicializacion de widgets
        self._wseleccion=widgetselector
        self._wopciones=widgetopciones

        zonastacksuperior=QtGui.QStackedWidget(self)
        zonastacksuperior.setMinimumSize(QtCore.QSize(200,200))
        zonastacksuperior.addWidget(self._wseleccion)
        zonastacksuperior.setCurrentWidget(self._wseleccion)
        zonastackinferior=QtGui.QStackedWidget(self)
        zonastackinferior.setMinimumSize(QtCore.QSize(200,200))
        zonastackinferior.addWidget(self._wopciones)
        zonastackinferior.setCurrentWidget(self._wopciones)

        self._rejilla.addWidget(zonastacksuperior,0,0)
        self._rejilla.addWidget(zonastackinferior,1,0)

        for x in listaopciones:
            self._wopciones.parse(x)

class WidgetCalculoSimple(WidgetOperacionSelectorOpcion):
    """Es un widget de calculo, con un selector simple y un widget de opciones suministrado en el constructor"""
    def __init__(self,name,listaopciones,interfazdatos):
        from wopciones import WOpciones
        wseleccion=seleccion.SelectorVariable(interfazdatos)
        wopciones=WOpciones(interfazdatos)
        WidgetOperacionSelectorOpcion.__init__(self,name,wseleccion,wopciones,listaopciones)

class WidgetCalculoSimpleBondadAjuste(WidgetCalculoSimple):
    """Es un widget especifico para todas las operaciones de bondad de ajuste"""
    def __init__(self,name,listadistribuciones,interfazdatos):
        listawidget=[]
        listawidget.append({"tipo":"SeleccionSimple","nombre":u"Distribución","opciones":listadistribuciones})
        listawidget.append({"tipo":"ListaSimple","nombre":u"Percentil","opciones":["95","90"]})
        WidgetCalculoSimple.__init__(self,name,listawidget,interfazdatos)
        
class WidgetCalculoDoble(WidgetOperacionSelectorOpcion):
    """Es un widget de calculo, con un selector doble y un widget de opciones suministrado en el constructor"""
    def __init__(self,name,listaopciones,interfazdatos):
        from wopciones import WOpciones
        import seleccion
        wseleccion=seleccion.SelectorDobleVariable(interfazdatos)
        wopciones=WOpciones(interfazdatos)
        WidgetOperacionSelectorOpcion.__init__(self,name,wseleccion,wopciones,listaopciones)


class WidgetCaso(WidgetOperacionSelectorOpcion):
    """Es un widget de calculo, con un selector variablevalor  y un widget de opciones suministrado en el constructor"""
    def __init__(self,name,listaopciones,interfazdatos):
        from wopciones import WOpciones
        import seleccion
        wseleccion=seleccion.SelectorVariableValor(interfazdatos)
        wopciones=WOpciones(interfazdatos)
        WidgetOperacionSelectorOpcion.__init__(self,name,wseleccion,wopciones,listaopciones)

class Widget2Variable3Casos(WidgetOperacionSelectorOpcion):
    """Es un widget de calculo, con un selector variablevalor  y un widget de opciones suministrado en el constructor"""
    def __init__(self,name,listaopciones,interfazdatos):
        from Driza.widgets.wopciones import WOpciones
        import seleccion
        wseleccion=seleccion.SelectorVariableVariableValor(interfazdatos)
        wopciones=WOpciones(interfazdatos)
        WidgetOperacionSelectorOpcion.__init__(self,name,wseleccion,wopciones,listaopciones)

class WidgetVariableCasoCaso(WidgetOperacionSelectorOpcion):
    """Es un widget de calculo, con un selector variablevalor  y un widget de opciones suministrado en el constructor"""
    def __init__(self,name,listaopciones,interfazdatos):
        from Driza.widgets.wopciones import WOpciones
        import seleccion
        wseleccion=seleccion.SelectorVariableValorValor(interfazdatos)
        wopciones=WOpciones(interfazdatos)
        WidgetOperacionSelectorOpcion.__init__(self,name,wseleccion,wopciones,listaopciones)

class WidgetVariableCasoCasoVariableVariable(WidgetOperacionSelectorOpcion):
    """Es un widget de calculo, con un selector variablevalor  y un widget de opciones suministrado en el constructor"""
    def __init__(self,name,listaopciones,interfazdatos):
        from Driza.widgets.wopciones import WOpciones
        import seleccion
        wseleccion=seleccion.SelectorVariableValorValorVariableVariable(interfazdatos)
        wopciones=WOpciones(interfazdatos)
        WidgetOperacionSelectorOpcion.__init__(self,name,wseleccion,wopciones,listaopciones)

class WidgetVariableCasoCasoVariable(WidgetOperacionSelectorOpcion):
    """Es un widget de calculo, con un selector variablevalor  y un widget de opciones suministrado en el constructor"""
    def __init__(self,name,listaopciones,interfazdatos):
        from wopciones import WOpciones
        import seleccion
        wseleccion=seleccion.SelectorVariableValorValorVariable(interfazdatos)
        wopciones=WOpciones(interfazdatos)
        WidgetOperacionSelectorOpcion.__init__(self,name,wseleccion,wopciones,listaopciones)

class WidgetGraficos(WidgetOperacion):
    """Widget de gráficos"""
    def __init__(self,name,listagraficos,listaopciones,interfazdatos):
        from Driza.widgets.wopciones import WOpciones
        WidgetOperacion.__init__(self,name)
        widget=QLabel(self)
        widget.setText(u"Prueba de gráficos")
        self._rejilla.addWidget(widget,0,0)
        self.wgraficos=WOpciones(interfazdatos)
        self._wopciones=WOpciones(interfazdatos)
        for x in listaopciones:
            self._wopciones.parse(x)
        for x in listagraficos:
            self.wgraficos.parse(x)
        zonastack1=QWidgetStack(self,"stack")
        zonastack1.setMinimumSize(QSize(200,200))
        zonastack1.addWidget(self.wgraficos)
        zonastack1.raiseWidget(self.wgraficos)
        zonastack2=QWidgetStack(self,"stack")
        zonastack2.setMinimumSize(QSize(200,200))
        zonastack2.addWidget(self._wopciones)
        zonastack2.raiseWidget(self._wopciones)
        
        self._rejilla.addWidget(zonastack1,1,0)
        self._rejilla.addWidget(zonastack2,2,0)

    def ejes(self):
        return self.wgraficos.opciones()

class WidgetDistribucion(WidgetOperacion):
    """Widget idoneo para los calculos asociados a las distribuciones"""
    def __init__(self,name,listacuantilesprob,listagrafica,interfazdatos):
        WidgetOperacion.__init__(self,name)
        from Driza.widgets.wopciones import WOpciones
        widget=WOpciones(interfazdatos)
        widget.addCO("Cuantiles")
        widget.addCO("Probabilidades")
        widget.addCO(u"Gráfica")
        widget.lista[0].addETS("Probabilidad")
        widget.lista[1].addETS("Valores")
        for x in listacuantilesprob:
            widget.lista[0].parse(x)
            widget.lista[1].parse(x)
            widget.lista[2].parse(x)
        widget.lista[0].parse({"nombre":u"DirecciónCola","tipo":"SeleccionSimple","opciones":["izquierda","derecha"]})
        widget.lista[1].parse({"nombre":u"DirecciónCola","tipo":"SeleccionSimple","opciones":["izquierda","derecha"]})
        widget.lista[2].parse({"tipo":"SeleccionSimple","nombre":"Tipografica","opciones":["Densidad",u"Distribución"]})
        widget.lista[0].setFrameStyle(QFrame.Sunken)
        widget.lista[0].setTitle("")
        widget.lista[1].setFrameStyle(QFrame.Sunken)
        widget.lista[1].setTitle("")
        widget.lista[2].setFrameStyle(QFrame.Sunken)
        widget.lista[2].setTitle("")
        zonastack=QWidgetStack(self,"stack")
        self._rejilla.addWidget(zonastack,0,0)
        zonastack.setMinimumSize(QSize(200,200))
        zonastack.addWidget(widget)
        zonastack.raiseWidget(widget)
        self._wopciones=widget
        
