#!/usr/bin/python
# -*- coding: utf-8 -*-

#Copyright (C) 2006-2007   Néstor Arocha Rodríguez, Inmaculada Luengo Merino

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from PyQt4 import QtCore,QtGui
from PyQt4.QtGui import QMessageBox
from Driza.datos.variables import * #Para poder preguntar por todos los tipos
import logging
log = logging.getLogger("Driza.iu.widgets.grid")


class QComboTableItem(QtGui.QItemDelegate):
    def createEditor(self,parent,opcionestilo,indicemodelo):
        editor=QtGui.QComboBox(parent)
        editor.installEventFilter(self)
    def setEditorData(self,editor,indicemodelo):
        """Obtiene valor del modelo y lo pone en el widget editor"""
        valor= indicemodelo.data(indicemodelo,QtGui.DisplayRole).toInt()
        editor.setValue(valor)
    def setModelData(self,editor,modelo,indicemodelo):
        editor.interpretText()
        valor=editor.value()
        modelo.setData(indicemodelo)
    def updateEditorGeometry(editor,opcionestilo,indicemodelo):
        editor.setGeometry(opcionestilo.rect)

class  Grid(QtGui.QTabWidget):
    """La tabla que manejara los registros y las variables"""

    #Funciones de inicializacion
    def __init__(self,padre,interfazdatos,porterodatos):
        """Inicializacion"""
        from Driza.datos.conversion import AgenteConversion
        self.__portero=porterodatos
        QtGui.QTabWidget.__init__(self)#,padre)
        #TODO Pendiente portabilidad qt4
        self.setTabPosition(QtGui.QTabWidget.South)
        self.tab = QtGui.QWidget(self)
        #TODO Pendiente portabilidad qt4
        tabLayout = QtGui.QVBoxLayout(self.tab)#,11,6,"tabLayout")
        self.table1 = QtGui.QTableWidget(self.tab)
        tabLayout.addWidget(self.table1)
        self.insertTab(0,self.tab,QtCore.QString.fromLatin1("&Registros"))
        self.tab_2 = QtGui.QWidget(self)
        #TODO Pendiente portabilidad qt4
        tabLayout_2 = QtGui.QVBoxLayout(self.tab_2)#,11,6,"tabLayout_2")
        self.table2 = QtGui.QTableWidget(self.tab_2)
        tabLayout_2.addWidget(self.table2)
        self.insertTab(1,self.tab_2,QtCore.QString.fromLatin1("&Variables"))

        self.__nreg=10 
        self.__nvar=10
        self.__interfazdatos=interfazdatos
        self.__inittabladat()
        self.__inittablavar()
        self.__conexiones()
        self.__agenteconversion=AgenteConversion(self.__interfazdatos)
        

    def __inittabladat(self):
        """Inicializa la tabla de datos"""
        self.table1.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)
        self.table1.setColumnCount(16) 
        self.table1.setRowCount(64)
        i=0
        qstringvacio=QtCore.QString('')
        qstringlist=QtCore.QStringList()
        for x in range(self.table1.horizontalHeader().count()):
            qstringlist.append(qstringvacio)
        self.table1.setHorizontalHeaderLabels(qstringlist)


    def __inittablavar(self):
        """Inicializa la tabla de variables"""
        self.table2.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)
        self.table2.setRowCount(self.__nvar)
        self.table2.setColumnCount(4)
        qstringlist=QtCore.QStringList()
        qstringlist.append(QtCore.QString.fromLatin1("Nombre"))
        qstringlist.append(QtCore.QString.fromLatin1("Tipo"))
        qstringlist.append(QtCore.QString.fromLatin1("Valor por defecto"))
        qstringlist.append(QtCore.QString.fromLatin1("Etiqueta"))
        self.table2.setHorizontalHeaderLabels(qstringlist)

    def __conexiones(self):
        from PyQt4.QtCore import SIGNAL
        self.connect(self.table1,SIGNAL("cellChanged(int,int)"),self.__modificaciontablareg)
        self.connect(self.table2,SIGNAL("cellChanged(int,int)"),self.__modificaciontablavar)

    
    #FUNCIONES SHOW

    def myUpdate(self):
        log.debug("Actualizando contenido de la ventana")
        self.__showtablavar()
        self.__showtabladat()



    def showEvent(self,ev):
        """Redefinición del show de la clase base"""
        self.myUpdate()
        QtGui.QTabWidget.showEvent(self,ev)
        

    def __showtablavar(self,pos=None):  
        """ Representa la variable pos en la tabla de variables. Las propiedades de la variable las lee de los datos.
        Si no se indica posicion, se entiende que se quiere rellenar toda la tabla
        """
        if pos:
            self.__showvar(pos)
            #Actualizacion de titulo en la tabla de datos
            self.__showtitulodat(pos)
        else:
            log.debug("Actualizando tabla de variables completa")
            if self.__nvar>(self.table2.rowCount()-self.__interfazdatos.numVar()):
                self.table2.setRowCount(self.__interfazdatos.numVar()+self.__nvar)
            for n in range(self.__interfazdatos.numVar(),self.table2.rowCount()):
                for y in range(self.table2.columnCount()):
                    pass
                    #TODO Pendiente portabilidad qt4
                    #self.table2.clearCell(n,y)
            for n in range(self.__interfazdatos.numVar()):
                self.__showvar(n)
            self.__showtitulodat()

    def __showvar(self,pos):
        """Muestra una unica variable (fila) en la tabla segun el listado de variables"""
        variable=self.__interfazdatos.getVar(pos)
        #self.table2.item(pos,0).setText(str(variable.nombre))
        if not(self.table2.item(pos,0) and str(variable.nombre)==self.table2.item(pos,0).text()):
            self.table2.setItem(pos,0,QtGui.QTableWidgetItem(str(variable.nombre)))
        #TODO Pendiente portabilidad qt4
        #modelo=QtGui.QStandardItemModel(pos,1)
        #self.table2.setModel(modelo)
        #self.table2.setItemDelegate(self.__combotableitem())
        #self.table2.setItem(pos,1,self.__combotableitem())    
        #self.table2.item(pos,1).setCurrentItem(variable.tipo)
        if not(self.table2.item(pos,2) and str(variable.valorpordefecto)==self.table2.item(pos,2).text()):
            self.table2.setItem(pos,2,QtGui.QTableWidgetItem(str(variable.valorpordefecto)))
        if not(self.table2.item(pos,3) and str(variable.descripcion)==self.table2.item(pos,3).text()):
            self.table2.setItem(pos,3,QtGui.QTableWidgetItem(str(variable.descripcion)))

    def __showtabladat(self,pos=None):
        """Muestra el dato en la posicion pos (fila)
        Lee de los datos, así que deben existir previamente
        Comprueba si esta filtrado o no para cambiar el color
        Si no se indica posicion, se entiende que se quiere rellenar toda la tabla
        """
        if pos:  
            #Se ha indicado la posición
            self.__showdat(pos)
        else: 
            #No se ha indicado la posicion, se rellena todo
            if self.__nreg>(self.table1.rowCount()-self.__interfazdatos.numReg()):
                self.table1.setRowCount(self.__interfazdatos.numReg()+self.__nreg)
            for x in range(self.__interfazdatos.numReg()):
                self.__showdat(x)
            self.__showtitulodat()
            for x in range(self.__interfazdatos.numReg(),self.table1.rowCount()):
                for y in range(self.table1.columnCount()):
                    #TODO Pendiente portabilidad qt4
                    #self.table1.clearCell(x,y)
                    pass
            for x in range(self.table1.rowCount()):
                for y in range(self.__interfazdatos.numVar(),self.table1.columnCount()):
                    #TODO Pendiente portabilidad qt4
                    #self.table1.clearCell(x,y)
                    pass
            self.__showlateraldat()

    def __showdat(self,pos):
        """Muestra un solo dato"""
        for i in range(self.__interfazdatos.numVar()):
            if not(self.table1.item(pos,i) and str(self.__interfazdatos[pos][i])==self.table1.item(pos,i).text()):
                self.table1.setItem(pos,i,QtGui.QTableWidgetItem(str(self.__interfazdatos[pos][i])))

    def __showColumnaTablaReg(self,pos):
        """Muestra una columna de la tabla de registros"""
        for i in range(self.__interfazdatos.numReg()):
            if not(self.table1.item(i,pos) and str(self.__interfazdatos[i][pos])==self.table1.item(i,pos).text()):
                self.table1.setItem(i,pos,QtGui.QTableWidgetItem(str(self.__interfazdatos[i][pos])))


    def __showtitulodat(self,pos=None):
        """Actualiza los titulos de la tabla de datos segun las variables"""
        if pos:
            self.table1.setHorizontalHeaderItem(pos,QtGui.QTableWidgetItem(self.__interfazdatos.getVar(pos).nombre))
        else:
            qstringlist=QtCore.QStringList()
            qstringvacio=QtCore.QString('')
            i=0
            for x in range(self.__interfazdatos.numVar()):
                qstringlist.append(QtCore.QString.fromLatin1(self.__interfazdatos.getVar(i).nombre))
                i+=1

            for x in range(self.__interfazdatos.numVar(),self.table1.horizontalHeader().count()):
                qstringlist.append(qstringvacio)
            self.table1.setHorizontalHeaderLabels(qstringlist)

    def __showlateraldat(self):
        """Muestra los numeros laterales. Sirve para el filtrado"""
        qstringlist=QtCore.QStringList()
        #lista=self.__interfazdatos.getCol(self.__gestorfiltro.variable,filtrado=False)
        for i in range(self.__interfazdatos.numReg()):
        #    if self.__gestorfiltro.variable and not lista[i]:
        #        lateral.setLabel(i,"--"+str(i))
        #    else:
            qstringlist.append(str(i+1))
        self.table1.setVerticalHeaderLabels(qstringlist)

    def __combotableitem(self,indice=0):
        """Devuelve un nuevo objeto tipo combotableitem con la lista de tipos"""
        lista=QtCore.QStringList()
        from Driza import listas
        for tipo in listas.variables():
            lista.append(tipo)
        return QComboTableItem()#self.table2)#,lista)
    
        
    def __modificaciontablavar(self,x,y):
        """Funcion a que conecta con la introduccion de nuevos datos en la tabla de variables"""
        if self.table2.currentRow()!=x or self.table2.currentColumn()!=y: return
        log.debug("Modificacion detectada en la tabla de variables")
        self.__portero.guardarestado()
        if x>=self.__interfazdatos.numVar(): #Es una nueva variable
            #Variables intermedias (creadas con los valores por defecto)
            for valorintermedio in range (self.__interfazdatos.numVar(),x):  
                self.__insertarvariable()
                self.__showtablavar(valorintermedio)
            self.__insertarvariable()
        #Variable modificada
        variable=self.__interfazdatos.getVar(x)
        if y==1:   # El usuario quiere cambiar el tipo
            from Driza.datos import variables
            textoencuestion=self.table2.text(x,y).latin1() 
            #preguntar el tipo de conversion
            metododeseado=self.__preguntarconversion(variable,textoencuestion)
            if metododeseado:
                pareja= self.__agenteconversion(variable,textoencuestion,metododeseado) #Pareja variable-list
                self.__interfazdatos.setVar(x,pareja[0],pareja[1])
                self.__showtabladat()  
        else: #Restos de campos (Texto)
            from Driza.excepciones import VariableExisteException
            try:
                self.__interfazdatos.modVar(variable,y,str(self.table2.item(x,y).text()))
            except VariableExisteException:
                rc = QMessageBox.warning(self,'Atención', u'El nombre de variable ya existe')

        self.__showtablavar(x)  
        #En todos los casos, actualizamos el titulo de la tabla de datos
        self.__showtitulodat()

    def __actualizarreginterfazdatos(self,x,y,valor):
        """actualiza un dato en interfazdatos,recogiendo la excepcion en caso de error """
        try:
            self.__interfazdatos[x][y]=self.__interfazdatos.getVar(y).nuevoitem(valor)
        except ValueError:
            rc = QMessageBox.warning(self,'Atención', u'El dato no es válido')
    
    def __insertarregistro(self):
        """Inserta un registro genérico, y ademas comprueba que no nos estamos acercando al final de la tabla"""
        self.__interfazdatos.appReg()
        if self.__nreg>(self.table1.rowCount()-self.__interfazdatos.numReg()):
            self.table1.setRowCount(self.table1.rowCount()+1)

    def __insertarvariable(self):
        """Inserta una variable genérica, y ademas comprueba que no nos acercamos a ninguno de los limites de las tablas"""
        self.__interfazdatos.appVar()
        if self.__nvar>(self.table2.rowCount()-self.__interfazdatos.numVar()):
            self.table2.setRowCount(self.table2.rowCount()+1)
            self.table1.setColumnCount(self.table1.columnCount()+1)

    def __modificaciontablareg(self,x,y):
        """Actualiza los datos del objeto dato a partir de un cambio en la tabla de datos"""
        if self.table1.currentRow()!=x or self.table1.currentColumn()!=y: return
        log.debug("Modificacion detectada en la tabla de registros")
        self.__portero.guardarestado()
        valor=self.table1.item(x,y).text()
        if y>=self.__interfazdatos.numVar():
            #Estamos trabajando sobre una variable inexistente
            for i in range(self.__interfazdatos.numVar(),y+1):
                self.__insertarvariable()
                self.__showColumnaTablaReg(i)
            self.__showtablavar() #actualizamos la tabla de variables
        if x>=self.__interfazdatos.numReg():
            #no existen registros intermedios
            for i in range (self.__interfazdatos.numReg(),x):  
                self.__insertarregistro()
                self.__showtabladat(i)  
            self.__interfazdatos.appReg() #El último se separa porque tenemos que verificar si el usuario ha escrito correctamente el dato
        self.__actualizarreginterfazdatos(x,y,valor)
        self.__showtabladat(x)
        #Comprobacion de que sobra el numero correcto de celdas
        if self.__nreg>(self.table1.rowCount()-self.__interfazdatos.numReg()):
            self.table1.setRowCount(self.__interfazdatos.numReg()+self.__nreg)
        self.parent().parent().parent().showundoredo() #FIXME... que son todos estos parent?

    
    def removeselection(self,borrardatos=False):
        """Esta funcion borra la seleccion de la tabla. El parametro opcional determina si se ha deborrar tambien los datos"""
        tablaactual=self.currentPageIndex()
        if tablaactual==0:
            tabla=self.table1
        else:
            tabla=self.table2
        if borrardatos:
            lista=[]
            for seleccion in range(tabla.numSelections()):
                for fila in range(tabla.selection(seleccion).topRow(),tabla.selection(seleccion).bottomRow()+1):
                    lista.append(fila)
            lista.sort()
            lista.reverse()
            for fila in lista:
                if tablaactual == 0:
                    del self.__interfazdatos[fila]
                else:
                    self.__interfazdatos.delVar(fila)

        for seleccion in range(tabla.numSelections()):
            tabla.removeSelection(seleccion)

    def __preguntarconversion(self,variable,objetivo):
        """Pregunta cual de los metodos disponibles para la conversion desea escoger el usuario"""
        from Driza.datos.agrupadores import Agrupador
        from Driza.datos.agrupadores import AgrupadorReal
        from Driza.datos.agrupadores import AgrupadorLogico
        from Driza.datos.agrupadores import AgrupadorEntero
        from Driza.datos.agrupadores import AgrupadorFactor
        #Leer el diccionario de variable con la key objetivo
        tipoinicial="Agrupador"+objetivo
        lista=[]
        for tipo in variable.diccionarioconversion.iterkeys():
            if issubclass(eval(tipoinicial),eval(tipo)):
                lista+=variable.diccionarioconversion[tipo]
        #Elaborar una lista y preguntar al usuario
        qlista=QStringList()
        for elemento in lista:
            qlista.append(elemento)
        cadena=QInputDialog.getItem("Elige!",u"Elige una función de conversion",qlista,0,False,self,"Dialogo")
        #devolver el nombre de la funcion
        if cadena[1]:
            return cadena[0].latin1()
        else:
            return ""

    def listaseleccion(self,tabla=0):
        """Devuelve una lista con los registros que han sido seleccionados"""
        tabla=self.table1
        cadena=""
        lista=[]
        listasalida=[]
        for seleccion in range(tabla.numSelections()):
            for fila in range(tabla.selection(seleccion).topRow(),tabla.selection(seleccion).bottomRow()+1):
                lista.append(fila)
        lista.sort() #En la lista estan todas las filas que se nos piden y ordenadas
        for x in lista:
            listasalida.append(self.__interfazdatos[x])

        return listasalida

